#!/usr/bin/perl 
#-Mencoding=euc-jp
$version = 'Time-stamp: "2019-09-04 12:56:57 yamagen"';
$version =~ s/Time-stamp/Version/g;
#
# poem.cgi for the graph modelling of Japanese poetic vocabulary
#
######################################################
#use encoding "euc-jp", STDIN => "utf8";
#use encoding "euc-jp", Filter=>1;
#use encoding "euc-jp";
#use Encode;
#use Encode::Guess qw/ shiftjis euc-jp 7bit-jis /;

#binmode STDIN, ':bytes';
#binmode STDIN, ':euc-jp';
#binmode STDOUT, ":euc-jp";
#binmode STDOUT, ":utf8";

#require "../poem/lib/jcode.pl";
require "../poem/lib/site-lib.pl";
require "../poem/lib/cgi-lib.pl";
&ReadParse;

$cat_sys       ='/bin/cat';       ## 755
$neato_sys     ='/usr/bin/neato';       ## 755
$nkf_sys       ='/usr/bin/nkf';      ## 755
$cw_sys        ='/home/yamagen/cw/src/cw';    ## 755
$cw2dot_sys    ='/home/yamagen/cw/src/cw2dotv3.pl';    ## 755
$rel_sys       ='/home/yamagen/cw/src/relv3.pl';    ## 755
$all_db        ='/home/yamagen/cw/db/all.db'; ## 755
$appli_name    ='./poem2.cgi';                ## 755
$home_name     ='../kokin.html';              ## 755
$info_name     ='../kokin_info.html';         ## 755
$help_name     ='../kokin_help.html';         ## 755
$config_file   ='../poem/lib/site.conf';      ## 666
$poem_db       ='../poem/lib/poem.db';        ## 666
$log_file      ='../poem/lib/log.txt';        ## 666

my $banner = '<br><img src=./cm.jpg width=700 height=40><br>';

# choka
my $eli  = ''; # init
$eli .= '11001,11002,11003,11005,11006,'; # kokin
$eli .= '30569,30571,30572,30573,30574,'; # goshuui
$eli .= '50713,50714,50715,50716,50717,'; # kinyou (no exist in nijl db)
$eli .= '71160,71161,71162,71163';        # senzai

#setting
$html = 1;

use POSIX qw(strftime);
$ddate       = strftime "%a %b %e %H:%M:%S %Y", localtime;
$fdate       = strftime "%Y/%m/%d %a %H:%M:%S", localtime;
$gdate       = strftime "%Y/%m/%d %H:%M:%S", localtime;

$this_title    ='';
$CharSet       ='x-euc-jp'; 
#$CharSet       ='UTF-8'; 

$|=1;
######################################################
# main
#####################################################

if ($in{'protocol'} eq 'calc')          {    calc_html();   }
elsif ( $in{'protocol'} eq 'config' )   {    config_html(); }
elsif ($ENV{'QUERY_STRING'} )           {    show_poem();   }
elsif ($in{'protocol'} eq '')           {    index_html();  }

######################################################
# sub 
######################################################

sub print_banner {
    print $banner . "<p>\n";
}

sub index_html {
    open_config($config_file);
    cgi_header();
    html_header();
    print_tools();
    print_banner();
    config_form();
    html_footer();
}

sub config_html {
    open_config($config_file);
    cgi_header();
    html_header();
    print_tools();
    print_banner();
    calc_form();
    html_footer();
}

sub show_poem {
    cgi_header();
    poem_lookup($in{'pid'});
}

sub poem_lookup {

    undef @c;
    $c[0] ='white';
    $c[1] ='mistyrose';


    undef %pid;
    $_[0] =~ s/pid=//g;
    my @m = split(/\,/, $_[0]);
    for ($i = 0; $i < $#m; $i++) {
	$pid{$m[$i]} = 1;
    }

    $i = 0;
    printf "<table cellpadding=7 hspace=0 cellspacing=0>\n";
    open(DB, $poem_db) or die ("can't open POEM.DB $poem_db.");
    while (<DB>) {
	next if /\#/;
	my ($fpid, $fau, $fpoem) = split(/\s+/, $_);
	if ($pid{$fpid}) {
	    $i++;
	    printf("<tr bgcolor=$c[$i % 2]>");
	    printf("<td align=right>%d.<td>%s<td>%s<td>%s</tr>\n", 
		   $i, $fpid, $fau, $fpoem);
	}
    }
    close(DB);
    printf "</table>\n";
}

sub config_form {

    print <<FO;
<form method='GET' action=$appli_name>
<input type='hidden' name='protocol' value='config'>
<table>
<tr><td> Key 1: <input type='text' name='Key1' size=20></tr>
<tr><td> Key 2: <input type='text' name='Key2' size=20></tr>
<tr><td> <input type='submit' name='submit' value='OK'></tr>
</table>
</form>
FO
}

sub get_dblist {
    undef %data;
    my $key = $_[0];
#    open(DB,'<:encoding(euc-jp)', $all_db) or print("can't open $all_db.");
    open(DB, $all_db) or print("can't open ALL.db $all_db.");
    while (<DB>) {
	next if !/$key/;
	my ($pid, $type, $bgnum, $kan, $hir, $dai, $pos) = split(/\s+/,$_);
	my $shu = int(substr($pid, 0, 2));
	$data{"$bgnum $kan $hir $dai"}->{freq}++;
	$data{"$bgnum $kan $hir $dai"}->{$shu}++;
    }
    close(DB);
    return %data;
}

sub calc_form {

    undef %data;
    my $list = '';
    $c[0] ='white';
    $c[1] ='mistyrose';
    my $j = 0;

#    $in{'Key'} = encode('euc-jp', decode('utf8', $in{'Key'}));
    foreach $i (keys %in){
#	jcode::convert(\$in{$i}, "euc");
      }

    %data = get_dblist($in{'Key1'});


    $opt = 'checked';
    foreach $i (sort {$data{$b}->{freq}<=>$data{$a}->{freq}} keys %data) {
	$j++;
	my ($bgnum, $kan, $hir, $dai, $pos) = split(/\s+/, $i);
	$list .= "<tr bgcolor=$c[$j % 2]>";
	$list .= "<td><input type='radio' name='bgnum1' value=$bgnum $opt>";
	$list .= "<td align=right>$data{$i}->{freq}";
	$list .= "<td>$bgnum <td>$kan <td> $hir <td> $dai";
	for ($k = 1; $k < 9; $k++) {
	    $list .= sprintf("<td align=right>%d", $data{$i}->{$k});
	}
	$list .= "</tr>\n";
	$opt = '';
    }


    $listone .= $list; 
    $list = '';


    %data = get_dblist($in{'Key2'});

    $opt = 'checked';
    foreach $i (sort {$data{$b}->{freq}<=>$data{$a}->{freq}} keys %data) {
	$j++;
	my ($bgnum, $kan, $hir, $dai, $pos) = split(/\s+/, $i);
	$list .= "<tr bgcolor=$c[$j % 2]>";
	$list .= "<td><input type='radio' name='bgnum2' value=$bgnum $opt>";
	$list .= "<td align=right>$data{$i}->{freq}";
	$list .= "<td>$bgnum <td>$kan <td> $hir <td> $dai";
	for ($k = 1; $k < 9; $k++) {
	    $list .= sprintf("<td align=right>%d", $data{$i}->{$k});
	}
	$list .= "</tr>\n";
	$opt = '';
    }

    $listtwo .= $list; 

    print <<FO;

ǡ١Key 1: $in{'Key1'} Key 2: $in{'Key2'}  򸡺ޤ<p>
<form method='GET' action=$appli_name>
<input type='hidden' name='protocol' value='calc'>
<table cellspacing=5>
<tr bgcolor=skyblue>
<td>
<td>и<td>ʬॳ<td>и<td><td>ɽ
<td>ź<td><td>佸<td>彦佸
<td>ս<td>ֽ<td>ܽ<td>ź
</tr>

$listone

<tr><td colspan=16><hr width="100%"></td></tr>

$listtwo

<tr  align=right bgcolor=#E0FFFF>
<td bgcolor=white>
<td bgcolor=white>
<td bgcolor=white>
<td bgcolor=white>
<td bgcolor=white>
<td>From
<td><input type='radio' name='shu_from' value='1' checked>
<td><input type='radio' name='shu_from' value='2'        >
<td><input type='radio' name='shu_from' value='3'        >
<td><input type='radio' name='shu_from' value='4'        >
<td><input type='radio' name='shu_from' value='5'        >
<td><input type='radio' name='shu_from' value='6'        >
<td><input type='radio' name='shu_from' value='7'        >
<td><input type='radio' name='shu_from' value='8'        >
</tr>

<tr align=right bgcolor=#E0FFFF>
<td bgcolor=white>
<td bgcolor=white>
<td bgcolor=white>
<td bgcolor=white>
<td bgcolor=white>
<td>To  
<td><input type='radio' name='shu_to' value='1' checked>
<td><input type='radio' name='shu_to' value='2'        >
<td><input type='radio' name='shu_to' value='3'        >
<td><input type='radio' name='shu_to' value='4'        >
<td><input type='radio' name='shu_to' value='5'        >
<td><input type='radio' name='shu_to' value='6'        >
<td><input type='radio' name='shu_to' value='7'        >
<td><input type='radio' name='shu_to' value='8'        >
</tr>
</table>

<table>
<tr bgcolor=#FFFFCC>
<td align=right>Level
<td><input type='radio' name='level' value='16' checked>16
<td><input type='radio' name='level' value='18'        >18
</tr>

<tr bgcolor=#FFFFCC>
<td align=right>Method
<td><input type='radio' name='method' value='7'  checked>7
<td><input type='radio' name='method' value='12'        >12
<!--
<td><input type='radio' name='method' value='13'        >13
<td><input type='radio' name='method' value='14'        >14
<td><input type='radio' name='method' value='15'        >15
<td><input type='radio' name='method' value='16'        >16
-->
</tr>

<tr bgcolor=#FDF5E6>
<td align=right> Unit Size
<td><input type='radio' name='unit' value='0' checked>0
<td><input type='radio' name='unit' value='1'        >1
<td><input type='radio' name='unit' value='2'        >2
</tr>

<tr bgcolor=#FDF5E6>
<td align=right> Z-score
<td><input type='radio' name='zscore' value='0'        >0
<td><input type='radio' name='zscore' value='1' checked>1
<td><input type='radio' name='zscore' value='2'        >2
</tr>

<tr bgcolor=#FDF5E6>
<td align=right> Log-Likelihood Value
<td><input type='radio' name='L' value='0' checked>None
<td><input type='radio' name='L' value='3.84'     >p < 0.05
<td><input type='radio' name='L' value='6.68'     >p < 0.01
</tr>

<tr bgcolor=#D3D3D3>
<td align=right>Co-occurrence Weight
<td><input type='radio' name='cw' value='1.0'        >1.0 
<td><input type='radio' name='cw' value='1.5'        >1.5 
<td><input type='radio' name='cw' value='1.6'        >1.6
<td><input type='radio' name='cw' value='1.7'        >1.7 
<td><input type='radio' name='cw' value='1.8'        >1.8 
<td><input type='radio' name='cw' value='1.9'        >1.9 
<td><input type='radio' name='cw' value='2.0'        >2.0 
<td><input type='radio' name='cw' value='2.1'        >2.1
<td><input type='radio' name='cw' value='2.2'        >2.2
<td><input type='radio' name='cw' value='2.3'        >2.3
<td><input type='radio' name='cw' value='2.4'        >2.4
<td><input type='radio' name='cw' value='2.5' checked>2.5
<td><input type='radio' name='cw' value='3.0'        >3.0 
<td><input type='radio' name='cw' value='3.5'        >3.5
<td><input type='radio' name='cw' value='4.0'        >4.0 
<td><input type='radio' name='cw' value='4.5'        >4.5
<td><input type='radio' name='cw' value='5.0'        >5.0 
</tr>
</table>

<input type='submit' name='submit' value='OK'>
</form>
FO
}

sub calc_html {

    unlink <*.svg>;
    unlink <*.png>;
    unlink <*.map>;
    unlink <*.dot>;

    open_config($config_file);
    cgi_header();
    html_header();
    print_tools();
    print_banner();

    my $bgnumone = substr($in{'bgnum1'}, 0, $in{'level'});
    my $bgnumtwo = substr($in{'bgnum2'}, 0, $in{'level'});

    my $unit = $in{'unit'};
    my $shu = "$in{'shu_from'}-$in{'shu_to'}";
    my $ll = $in{'L'};
    my $cw = $in{'cw'};
    my $method = $in{'method'};
    my $zscore = $in{'zscore'};
#    $debug = 1;
    if ($debug) {
	foreach $i (sort keys %in) {
	    print "$i $in{$i}<br>\n";
	}
    }

    my $prefix = "$$";

    my $optone = "-E $eli -M $method -W $cw -L $ll ";
    $optone   .= "-F $shu -C $unit -K $bgnumone -Z $zscore";

    my $opttwo = "-E $eli -M $method -W $cw -L $ll ";
    $opttwo   .= "-F $shu -C $unit -K $bgnumtwo -Z $zscore";

    open(LOG, ">>$log_file") or die print "can't open LOG $logfile.<br>\n";    
    print LOG "$gdate ";
    print LOG "$bgnumone ";
    print LOG "$bgnumtwo ";
    print LOG "$shu ";
    print LOG "$unit ";
    print LOG "$method ";
    print LOG "$cw ";
    print LOG "$ll ";
    print LOG "$zscore ";
    print LOG "\n";
    close(LOG);

    $outsize = 0;

# CFLAGS="-Os -march=i686 -DJISX0208" \
#./configure --prefix=$HOME
# EUCΤǥѥ뤷Ƥ, 0Ǥ褤
#
#    system("$cw_sys -T svg $opt $all_db | $nkf_sys -w > svg.dot");
#    system("$neato_sys -Tsvg svg.dot > $prefix.svg");
#    system("$cw_sys -T png $opt $all_db | $nkf_sys -w > png.dot");
#    system("$neato_sys -Tpng -o$prefix.png png.dot");
#    system("$neato_sys -Tcmapx png.dot | $nkf_sys -e > $prefix.map");

#
#   KEY CT BG-01-5520-20-11  11 88 4.70 2.50 86 K:1-1 L:0.00 U:0 M:7 Z:1.00 
#   KEY RS -CT-20-198-3.71-15.5 -CT-43-298-3.30-15


#% cat tabledir/table-warbler-CT.txt tabledir/table-cuckoo-CT.txt \
#%  |relv3.pl -g4 -c| cw2dotv3.pl -e | neato -Tps -Gstart=20 -Elen=1.2 \
#% -o t.eps

    my $ret = 0;

    $ret = system("$cw_sys -mT svg $optone $all_db > one.list");
    print "Error occurred at $cw_sys svg $optone<br>\n" if ($ret);
    $ret = system("$cw_sys -mT svg $opttwo $all_db > two.list");
    print "Error occurred at $cw_sys svg $opttwo<br>\n" if ($ret);
    $ret = system("$cat_sys *.list | $rel_sys -g4 -c | $cw2dot_sys |$nkf_sys -w | $neato_sys -Tsvg:cairo > $prefix.svg"); 
    my $script = "$cat_sys *.list | $rel_sys -g4 -c | $cw2dot_sys |$nkf_sys -w | $neato_sys -Tsvg:cairo > $prefix.svg";
    print "Error occurred at $cat_sys svg $opttwo<br>\n" if ($ret);
    print "SCRIPT: $script<br>\n" if (!$ret);
    unlink glob('./*.eps') or print "Rm errors($!)";
    #print "remove<br>";
    $ret = system("$cat_sys *.list | $rel_sys -g4 -c | $cw2dot_sys |$nkf_sys -w | $neato_sys -Tps:cairo > $prefix.eps"); 
    print "EPS: <a href=\"./$prefix.eps\">$prefix.eps</a><br>\n" if (!$ret);


    $ret = system("$cw_sys -mT png $optone $all_db > one.list");
    print "Error occurred at $cw_sys png $opttwo<br>\n" if ($ret);
    $ret = system("$cw_sys -mT png $opttwo $all_db > two.list");
    print "Error occurred at $cw_sys png $opttwo<br>\n" if ($ret);
    $ret = system("$cat_sys *.list | $rel_sys -g4 -c | $cw2dot_sys | $nkf_sys -w > png.dot");
    print "Error occurred at $cat_sys png $rel_sys<br>\n" if ($ret);

    $ret = system("$neato_sys -Tpng:cairo   png.dot > $prefix.png");
    print "Error occurred at $neato_sys png $rel_sys<br>\n" if ($ret);
    $ret = system("$neato_sys -Tcmapx:cairo png.dot | $nkf_sys -e > $prefix.map");
    print "Error occurred at $neato_sys cmapx $rel_sys<br>\n" if ($ret);

    open(MA, "$prefix.map") or print "can't open map file.<br>\n";
    while (<MA>) {
	$mapfile .= $_;
    }
    close(MA);
    
    print_obj($prefix);
    print "<p>\n";
    html_footer();
}

sub print_obj {
    $prefix = $_[0];
    print <<OBJ;
<object type="image/svg+xml" data="$prefix.svg" height=800 width=800>
<svg="$prefix.svg">
<object type="image/svg+xml" data="$prefix.svg" height=800 width=800>
<img src="$prefix.png" USEMAP="#G" />
$mapfile
</object>
OBJ
}
